include (jslib_date);

// global
var gClockID = 0;

function getClock ()
{
  return document.getElementById('clock');
}

function toggleTime ()
{
  if (getClock().getAttribute("time")) {
    stopClock();
    startDate();
  } else {
    stopDate();
    startClock();
  }
}

function setDate ()
{
  getClock().setAttribute("value", date("M jS, Y"));
  getClock().removeAttribute("time");
}

function setClock ()
{
  var clockFormat = "h:i:s A";
  if( clockIs24() )
  {
    if( clockHasSeconds() )
      clockFormat = "H:i:s";
    else
      clockFormat = "H:i";
  }
  else
  {
    if( !clockHasSeconds() )
      clockFormat = "h:i A";
  }
  getClock().setAttribute("value", date(clockFormat));
  getClock().setAttribute("time", true);
}

function updateClock () 
{
   if (gClockID) {
      clearTimeout(gClockID);
      gClockID  = 0;
   }

   setClock();
   gClockID = setTimeout("updateClock()", 1000);
}

function updateDate () 
{
   if (gClockID) {
      clearTimeout(gClockID);
      gClockID  = 0;
   }

   setDate();
   gClockID = setTimeout("updateDate()", 1000);
}

function startClock () 
{
   if (!clockIsArmed()) {
     hideClock();
     stopClock();
     return;
   }

   showClock();
   gClockID = setTimeout("updateClock()", 500);
}

function startDate () 
{
   setDate();
   gClockID = setTimeout("updateDate()", 500);
}

function stopClock () 
{
   if (gClockID) {
      clearTimeout(gClockID);
      gClockID  = 0;
   }
}

function stopDate () 
{
   if (gClockID) {
      clearTimeout(gClockID);
      gClockID  = 0;
   }
}

function clockIsArmed ()
{
  var menu = document.getElementById("clock-toggle");
  var rv = eval(menu.getAttribute("checked"));
  return rv;
}

function clockIs24 ()
{
  var menu = document.getElementById("12-toggle");
  var rv = eval(menu.getAttribute("checked"));
  return rv;
}

function clockHasSeconds ()
{
  var menu = document.getElementById("second-toggle");
  var rv = eval(menu.getAttribute("checked"));
  return rv;
}

function enableClock ()
{
  setTimeout("startClock()", 1000);
}

function hideClock ()
{
  var menu = document.getElementById("clock");
  menu.collapsed = true;
}

function showClock ()
{
  var menu = document.getElementById("clock");
  menu.collapsed = false;
}

setTimeout("startClock()", 1000);

